;----------------------------------""   ----------------------------------------
;*********************************************************************************************
;   : irs_v111.asm
;     IK  v.1.11
; ( ,   ,   )
;********************************************************************************************* 
; :    . . ,    2008.
; E-mail:  isa33775@gmail.com              
;*********************************************************************************************
;   PIC16F628A.   4000.
;*********************************************************************************************

;=============================================================================================
;  ""   : LIST, __CONFIG, equ, org.
;============================================================================================= 
            LIST       p=16F628A   ;   : PIC16F628A.
            __CONFIG   03F25H      ; :  , WDT ,
                                   ;  XT-, PWRTE 
;=============================================================================================
;     .
;=============================================================================================
OptionR     equ        01h         ;  Option - 1
PC          equ        02h         ; PC
Status      equ        03h         ;  Status
PortA       equ        05h         ;  A
TrisA       equ        05h         ;  Tris A - 1
PortB       equ        06h         ;  B
TrisB       equ        06h         ;  Tris B - 1
IntCon      equ        0Bh         ;  IntCon
PIR1        equ        0Ch         ; PIR1

EEData      equ        1Ah         ; EEPROM -  - 1.
EEAdr       equ        1Bh         ; EEPROM -  - 1.
EECon1      equ        1Ch         ; EECON1 - 1.
EECon2      equ        1Dh         ; EECON2 - 1.

VRCON       equ        1Fh         ; VRCON - 1.   .
CMCON       equ        1Fh         ;  .
T1CON       equ        10h         ;  TMR1.
T2CON       equ        12h         ;  TMR2.
CCP1CON     equ        17h         ;  CCP.
RCSTA       equ        18h         ;  USART.
;=============================================================================================
;       .
;=============================================================================================
Sec         equ        70h         ; .
SecH        equ        71h         ;   .
SecL        equ        72h         ;   .
Registr     equ        73h         ;   ,     EEPROM.
;=============================================================================================
;         
; ,     
;=============================================================================================
W           equ        0           ;    .
F           equ        1           ;    .
;=============================================================================================
;    .
;=============================================================================================
RP0         equ        5           ;  5-   STATUS  RP0.
RP1         equ        6           ;   .
GIE         equ        7           ;    .
;=============================================================================================
;    EEPROM.
;=============================================================================================
            org        2100h       ;   EEPROM  .
            DE         16h         ;      00h  (16h=0001 0000). 
            DE         "       "                                  ;    . 
            DE         " IvanytaS.A. RusSt.Oskol"                 ;   .
            DE         "  2008   v.1.11 isa33775@gmail.com      " ;   .
;=============================================================================================
;     .
;=============================================================================================
            org        0           ;       PC.
            goto       START       ;     START.
;*********************************************************************************************
;-------------------------------      -----------------------------------
;*********************************************************************************************
;  .
;---------------------------------------------------------------------------------------------
START       clrf       IntCon      ;       IntCon.
            clrwdt                 ;      WDT.

            bsf        Status,RP0  ; "" ""  
            bcf        Status,RP1  ; 1- .
            clrf       VRCON       ;    .
            movlw      b'11111111' ;    w .
            movwf      TrisA       ;     TrisA  1.
            movlw      b'11101110' ;    W .
            movwf      TrisB       ;  0,4-   TrisB  0,    1.
            movlw      b'10001111' ;    W .
            movwf      OptionR     ;  4,5,6-  OptionR  0,    0.
  
            bcf        Status,RP0  ;  0-  (   
                                   ; 0-  1- ,    ).
            movlw      .37         ;  2    .
            movwf      CMCON       ;  .
            clrf       RCSTA       ;  RCSTA
            clrf       T1CON       ;  T1CON
            clrf       T2CON       ;  T2CON
            clrf       CCP1CON     ;  CCP1CON
;===============================================================================================
;                                  EEPROM
;===============================================================================================
;      00h        Registr.
;-----------------------------------------------------------------------------------------------
            bsf        Status,RP0  ;   1- .
            bcf        EECon1,2    ;    EEPROM.

            movlw      0           ;    W  00h.
            movwf      EEAdr       ;  00h   W   EEAdr.
            bsf        EECon1,0    ;  .
            movf       EEData,W    ;     EEPROM   00h  W.
            movwf      Registr     ;     W   Registr.
            bcf        Status,RP0  ;   0- .
;--------------------------------------------------------------------------------------------
;       .
;--------------------------------------------------------------------------------------------
            movlw      .0          ;    W .
            movwf      PortA       ;   0 PortA. 
            movwf      PortB       ;   0 PortB.
;--------------------------------------------------------------------------------------------
;    IR     .
;--------------------------------------------------------------------------------------------
CYCLE       clrwdt                 ;      WDT.
            btfsc      PIR1,6      ;    .
            call       IMP         ;     .  
            btfss      PortB,5     ;  IRDA.
            goto       IR          ;   IRDA.
            btfss      PortB,1     ;  .
            call       BUTTON      ;     .
            goto       CYCLE       ;     CYCLE.
;--------------------------------------------------------------------------------------------
;   IR.
;--------------------------------------------------------------------------------------------
IR          movlw      .10         ;    W  .10 ( 10 )
            movwf      SecH        ;   .30   W   Sec.
            movlw      .255        ;    W  .255
            movwf      SecL        ;   .255   W   SecL.

CYCLE1      btfsc      PortB,5     ;  6   PortB  1,  goto CYCLE.
            goto       CYCLE       ;     .

PAUSE1      clrwdt                 ;      WDT.
            btfsc      PIR1,6      ;    .
            call       IMP         ;     .  

            decfsz     SecL,F      ;  (-1)   SecL  
            goto       PAUSE1      ;    .                    
            decfsz     SecH,F      ;    
            goto       CYCLE1      ;     CYCLE1.
            goto       ONOFF       ;    ONOFF.
;--------------------------------------------------------------------------------------------
;   .
;--------------------------------------------------------------------------------------------
BUTTON      movlw      .30         ;    W  .30
            movwf      Sec         ;   .30   W   Sec.
            movlw      .255        ;    W  .255
            movwf      SecL        ;   .255   W   SecL.

CYCLE1B     clrwdt                 ;      WDT.
            btfsc      PortB,1     ;  1   PortB  1,  
                                   ;  (goto CYCLE1)
            goto       CYCLE       ;     
PAUSE1B     clrwdt                 ;      WDT.          
            decfsz     SecL,F      ;  (-1)   SecL  
            goto       PAUSE1B     ;    .                    
            decfsz     Sec,F       ;    
            goto       CYCLE1B     ;     CYCLE01.
;--------------------------------------------------------------------------------------------
;     .
;--------------------------------------------------------------------------------------------
ONOFF       swapf      Registr,Registr ;   /    Registr.
;===============================================================================================
;                                   EEPROM.             
;===============================================================================================
;    Registr   EEPROM   00h.
;-----------------------------------------------------------------------------------------------
            clrf       IntCon      ;   .
            bsf        Status,RP0  ;   1- .

            movlw      0           ;    W  00h.
            movwf      EEAdr       ;   00h   W   EEAdr.
            movf       Registr,W   ;     Registr   W.
            movwf      EEData      ;     W   EEPROM   00h.
            bsf        EECon1,2    ;    EEPROM.

            bcf        Status,RP0  ;   0- .
            bcf        PIR1,7      ;        EEPROM.
            bsf        Status,RP0  ;   1- . 
                                    
            movlw      055h        ; 
            movwf      EECon2      ; 
            movlw      0AAh        ;  .
            movwf      EECon2      ; ----"----
            bsf        EECon1,1    ; ----"----

            bcf        Status,RP0  ;   0- .

wr1         clrwdt                 ;      WDT.
            btfss      PIR1,7      ;         EEPROM
                                   ;  ,      .
            goto       wr1         ;      .
            bsf        Status,RP0  ;   1- .        
            bcf        EECon1,4    ;        EEPROM.
            bcf        Status,RP0  ;    . 
;--------------------------------------------------------------------------------------------
;    1,5 c.
;--------------------------------------------------------------------------------------------
            movlw      .255        ;    W  .255 ( ).
            movwf      SecH        ;   .255    W   SecH.

            movlw      .255        ;    W  .255
            movwf      SecL        ;   .255   W   SecL.

PAUSE2      clrwdt                 ;      WDT.
            btfsc      PIR1,6      ;    .
            call       IMP         ;     .  

            decfsz     SecL,F      ;  (-1)   SecL  
            goto       PAUSE2      ;    .                    
                                   ;    =0,    -
                                   ; ,   =0,    
                                   ;  (  - nop) 

            decfsz     SecH,F      ;   ,      
            goto       PAUSE2      ; SecL,     SecH.

            goto       CYCLE       ;    CYCLE.
;============================================================================================
; 
;============================================================================================
;     (1 ).
;--------------------------------------------------------------------------------------------
IMP         movf       Registr,W   ;     Registr   W.
            movwf      PortB       ;  PortB.
            movlw      .200         ;    W  .100
            movwf      Sec         ;   .100   W   SecL.

PAUSE3      decfsz     Sec,F       ;  (-1)   SecL.
            goto       PAUSE3      ;                    
            movlw      .0          ;    W .
            movwf      PortB       ;   0 PortB.
            movf       CMCON,W     ;  .
            bcf        PIR1,6      ;     .
            return                 ;
;============================================================================================
            end                    ;    .

